/*
    ParaGUI - crossplatform widgetset
    Copyright (C) 2000  Alexander Pipelka

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Alexander Pipelka
    pipelka@teleweb.at

    Last Update:      $Author: pipelka $
    Update Date:      $Date: 2001/01/26 13:35:04 $
    Source File:      $Source: /usr/local/CVSROOT/linux/paragui/src/paragui_msgmap.h,v $
    CVS/RCS Revision: $Revision: 1.6 $
    Status:           $State: Exp $
*/

#ifndef PARAGUI_MSGMAP_H
#define PARAGUI_MSGMAP_H

#include "paragui.h"
#include "sdlmessageobject.h"

/**
	ParaGUI eventhandler data structure
*/

typedef struct PARAGUI_EVENTHANDLERDATA {

	/** the function to call */
	MSG_CALLBACK cbfunc;

	/** the object to call **/
	SDLMessageObject* calledobj;

	/** pointer to userdata */
	void* data;

} PARAGUI_EVENTHANDLERDATA;

/**
	Searches for a specific eventhandler

	@param	type			the messagetype
	@param	obj			the emiting SDLMessageObject
*/

PARAGUI_EVENTHANDLERDATA* PARAGUI_FindEventHandler(MSG_TYPE type, SDLMessageObject* obj);

/**
	Register a new eventhandler for an object

	@param	type			the messagetype
	@param	obj			the messageobject
	@param	cbfunc		the callback function to register
	@param	data			optional userdata
*/

bool PARAGUI_RegisterEventHandler(MSG_TYPE type, SDLMessageObject* obj, MSG_CALLBACK cbfunc, void* data);

/**
	Unregister an objects eventhandler

	@param	type			the messagetype to unregister
	@param	obj			the messageobject
*/

bool PARAGUI_UnregisterEventHandler(MSG_TYPE type, SDLMessageObject* obj);

/**
	Unregister all eventhandlers of an object

	@param	obj			the messageobject to unregister
*/

bool PARAGUI_UnregisterEventObject(SDLMessageObject* obj);


#endif // PARAGUI_MSGMAP_H

