/*
    ParaGUI - crossplatform widgetset
    Copyright (C) 2000  Alexander Pipelka
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
 
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
 
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
    Alexander Pipelka
    pipelka@teleweb.at
 
    Last Update:      $Author: pipelka $
    Update Date:      $Date: 2001/01/26 13:35:04 $
    Source File:      $Source: /usr/local/CVSROOT/linux/paragui/src/paragui_types.h,v $
    CVS/RCS Revision: $Revision: 1.21 $
    Status:           $State: Exp $
*/

#ifndef PARAGUI_TYPES_H
#define PARAGUI_TYPES_H

#ifdef SWIG
%include "swigcommon.h"
%module paragui_types
%{
#include "paragui_types.h"
%}
#endif

// Forward declarations

class SDLMessageObject;
class SDLWidget;


#ifdef __cplusplus
extern "C" {
#endif

// SDL_Point

typedef struct {
	int x;
	int y;
}
SDL_Point;


// SDL_Gradient

typedef struct {
	SDL_Color colors[4];
}
SDL_Gradient;

typedef unsigned long MSG_ID;
typedef unsigned long MSG_DATA;

typedef enum _MSG_TYPE {
	MSG_BUTTONCLICK,
	MSG_SCROLLPOS,
	MSG_SCROLLTRACK,
	MSG_SLIDE = MSG_SCROLLTRACK,
	MSG_THREAD_SIGNAL,
	MSG_SIGNAL,
	MSG_QUIT,
	MSG_EDITBEGIN,
	MSG_EDITEND,
	MSG_APPIDLE,
	MSG_SELECTITEM
} MSG_TYPE;

#define PARAGUI_CALLBACK(funcname) \
bool funcname (int id, SDLWidget* widget, unsigned long data, void *clientdata)

typedef bool (*MSG_CALLBACK)(int id, SDLWidget* widget, unsigned long data, void *clientdata);

// MSG_MESSAGE

typedef struct {
	MSG_TYPE	type;
	SDLMessageObject* from;
	SDLMessageObject* to;
	unsigned long widget_id;
	unsigned long data;
	SDL_Point pt;
}
MSG_MESSAGE;

#ifdef __cplusplus
}
#endif

#endif // PARAGUI_TYPES_H
