/*
    ParaGUI - crossplatform widgetset
    Copyright (C) 2000  Alexander Pipelka
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
 
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
 
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
    Alexander Pipelka
    pipelka@teleweb.at
 
    Last Update:      $Author: pipelka $
    Update Date:      $Date: 2000/11/15 11:08:01 $
    Source File:      $Source: /usr/local/CVSROOT/linux/paragui/src/sdlbuttongroup.h,v $
    CVS/RCS Revision: $Revision: 1.14 $
    Status:           $State: Exp $
*/

#ifndef SDLBUTTONGROUP_H
#define SDLBUTTONGROUP_H

#ifdef SWIG
%include "swigcommon.h"
%module sdlbuttongroup
%{
#include "sdlbuttongroup.h"
%}
#endif

#include "sdlgradientwidget.h"
#include "sdlbutton.h"

/**
	@author Alexander Pipelka
	
	@short A group of SDLButtons

	An array of SDLButtons with functions to tie them together in various ways.
FIXME: what is this used for?
*/

class DECLSPEC SDLButtonGroup : public SDLGradientWidget {
public:
	SDLButtonGroup(SDLWidget* parent, int id, SDL_Rect& r, int x, int y, int d=1);
	~SDLButtonGroup();

	void Activate(int x, int y, int d=0);
	void Deactivate(int x, int y, int d=0);
	void Show();
	void SwitchTo(int d);
	void BlendTo(int d);

	void SetText(int x, int y, int d, char* text);

	SDLButton* GetButton(int x, int y, int d);

	virtual bool OnButton(int x, int y, int d, SDLWidget* widget);

protected:
	int GetIndex(int x, int y, int d);

	/** Event Handler */
	bool eventButtonClick(int id, SDLWidget* widget);

private: // disable the copy operators
	SDLButtonGroup(const SDLButtonGroup&);
	SDLButtonGroup& operator=(const SDLButtonGroup&);
	
private:
	void GetPosFromId(int id, int& x, int& y, int& d);

	SDLButton** btnArray;
	Uint8*		actArray;
	int			count_x;
	int			count_y;
	int			count_d;
	int			current_depth;
};


#endif // SDLBUTTONGROUP_H
