/*
    ParaGUI - crossplatform widgetset
    Copyright (C) 2000  Alexander Pipelka

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Alexander Pipelka
    pipelka@teleweb.at

    Last Update:      $Author: pipelka $
    Update Date:      $Date: 2001/01/24 21:19:36 $
    Source File:      $Source: /usr/local/CVSROOT/linux/paragui/src/sdlcolumnitem.h,v $
    CVS/RCS Revision: $Revision: 1.3 $
    Status:           $State: Exp $
*/

#ifndef SDLCOLUMNITEM_H
#define SDLCOLUMNITEM_H

#ifdef SWIG
%include "swigcommon.h"
%module sdlcolumnitem
%{
#include "sdlcolumnitem.h"
%}
#endif

#include "sdllistboxitem.h"

class DECLSPEC SDLColumnItem : public SDLListBoxItem {
public:

	/** */
	SDLColumnItem(int columns, int height, void* userdata = NULL);

	/** */
	~SDLColumnItem();

	/** */
	void SetColumnWidth(int column, int width);

	/** */
	void SetColumnText(int column, char* text);
	
protected:

	/** */
	void eventDraw(SDL_Surface* surface, SDL_Rect* rect);

	/** */
	void eventBlit(SDL_Surface* srf, SDL_Rect* src, SDL_Rect* dst);

private:

	int my_columncount;
	int my_columnwidth[10];
	char my_columntext[10][255];
	SDL_Surface* my_srfColumn[10];
};

#endif		// SDLCOLUMNITEM_H
