/*
    ParaGUI - crossplatform widgetset
    Copyright (C) 2000  Alexander Pipelka

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Alexander Pipelka
    pipelka@teleweb.at

    Last Update:      $Author: pipelka $
    Update Date:      $Date: 2001/01/24 21:19:36 $
    Source File:      $Source: /usr/local/CVSROOT/linux/paragui/src/sdllistbox.h,v $
    CVS/RCS Revision: $Revision: 1.5 $
    Status:           $State: Exp $
*/

#ifndef SDLLISTBOX_H
#define SDLLISTBOX_H

#ifdef SWIG
%include "swigcommon.h"
%module sdllistbox
%{
#include "sdllistbox.h"
%}
#endif

#include "sdlwidgetlist.h"
#include "sdllistboxitem.h"

class DECLSPEC SDLListBox : public SDLWidgetList {
public:

	/** */
	SDLListBox(SDLWidget* parent, SDL_Rect r);

	/** */
	~SDLListBox();

	/** */
	void AddItem(SDLListBoxBaseItem* item);

	/** */
	void SetMultiSelect(bool multi = true);

	/** */
	bool GetMultiSelect();
	
	/** */
	SDLListBoxBaseItem* GetSelectedItem();

	/** */
	void SelectItem(SDLListBoxBaseItem* item, bool select = true);

	/**
	Remove all widgets from the list (without deletion)
	*/
	void RemoveAll();

	/**
	Delete (destroy) all widgets in the list
	*/
	void DeleteAll();

protected:

	/** */
	bool eventSelectItem(SDLListBoxBaseItem* item);

	/** */
	bool eventMouseButtonUp(const SDL_MouseButtonEvent* button);

	/** */
	bool eventMouseButtonDown(const SDL_MouseButtonEvent* button);

	/** */
	bool eventMouseMotion(const SDL_MouseMotionEvent* motion);

private:
	
	void AddWidget(SDLWidget* w);

	bool my_multiselect;
	SDLListBoxBaseItem* my_selectedItem;

};

#endif	// SDLLISTBOX_H
