/*
    ParaGUI - crossplatform widgetset
    Copyright (C) 2000  Alexander Pipelka

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Alexander Pipelka
    pipelka@teleweb.at

    Last Update:      $Author: pipelka $
    Update Date:      $Date: 2001/01/18 18:11:06 $
    Source File:      $Source: /usr/local/CVSROOT/linux/paragui/src/sdllistboxbaseitem.h,v $
    CVS/RCS Revision: $Revision: 1.1 $
    Status:           $State: Exp $
*/

#ifndef SDLLISTBOXBASEITEM_H
#define SDLLISTBOXBASEITEM_H

#include "sdllabel.h"

class SDLListBox;

class DECLSPEC SDLListBoxBaseItem : public SDLLabel {
public:

	/** */
	SDLListBoxBaseItem(int height, void* userdata = NULL);

	/** */
	~SDLListBoxBaseItem();

	/** */
	void SetUserData(void* userdata);

	/** */
	void* GetUserData();

	/** */
	bool IsSelected();

	/** */
	void Select(bool select = true);

	/** */
	int Height();

	/** */
	SDLListBox* GetParent();

protected:

	/** */
	void eventMouseEnter();

	/** */
	void eventMouseLeave();

	/** */
	bool eventMouseButtonUp (const SDL_MouseButtonEvent* button);

	void* my_userdata;
	bool my_selected;
	bool my_hover;
	int my_height;
};

#endif	// SDLLISTBOXBASEITEM_H
