/*
    ParaGUI - crossplatform widgetset
    Copyright (C) 2000  Alexander Pipelka

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Alexander Pipelka
    pipelka@teleweb.at

    Last Update:      $Author: pipelka $
    Update Date:      $Date: 2001/01/24 21:19:36 $
    Source File:      $Source: /usr/local/CVSROOT/linux/paragui/src/sdllistboxitem.h,v $
    CVS/RCS Revision: $Revision: 1.4 $
    Status:           $State: Exp $
*/

#ifndef SDLLISTBOXITEM_H
#define SDLLISTBOXITEM_H

#ifdef SWIG
%include "swigcommon.h"
%module sdllistboxitem
%{
#include "sdllistboxitem.h"
%}
#endif


#include "sdllistboxbaseitem.h"

class SDLListBox;

class DECLSPEC SDLListBoxItem : public SDLListBoxBaseItem {
public:

	/** */
	SDLListBoxItem(int height, char* text = NULL, SDL_Surface* icon = NULL, void* userdata = NULL);

	/** */
	~SDLListBoxItem();

	/** */
	void LoadThemeStyle(const char* widgettype, const char* objectname);

protected:

	/** */
	void eventBlit(SDL_Surface* srf, SDL_Rect* src, SDL_Rect* dst);
	
private:

	SDL_Gradient* my_gradient[3];
	SDL_Surface* my_background[3];
	int my_bkmode[3];
	Uint8 my_blend[3];
};

#endif	// SDLLISTBOXITEM_H
