/*
    ParaGUI - crossplatform widgetset
    Copyright (C) 2000  Alexander Pipelka
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
 
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
 
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
    Alexander Pipelka
    pipelka@teleweb.at
 
    Last Update:      $Author: pipelka $
    Update Date:      $Date: 2001/01/17 18:22:47 $
    Source File:      $Source: /usr/local/CVSROOT/linux/paragui/src/sdlprogressbar.h,v $
    CVS/RCS Revision: $Revision: 1.14 $
    Status:           $State: Exp $
*/

#ifndef SDLPROGRESSBAR_H
#define SDLPROGRESSBAR_H

#ifdef SWIG
%include "swigcommon.h"
%module sdlprogressbar
%{
#include "sdlprogressbar.h"
%}
#endif

#include "sdlgradientwidget.h"

/**
	@author Alexander Pipelka

	@short A progress bar.

	Displays progress by taking a percentage and sizing the bar appropriately.
*/
/* Perhaps this could be created with a 'max value' attribute (or what 100%
 * actually is) to ease the load on the application coder so he does not have
 * to worry about converting to percent?
 */
class DECLSPEC SDLProgressBar : public SDLGradientWidget {
public:

	/** */
	SDLProgressBar(SDLWidget* parent, SDL_Rect& r);

	/** */
	~SDLProgressBar();

	/** */
	void SetProgress(double p);

	void LoadThemeStyle(const char* widgettype);

protected:

	/** */
	void eventDraw(SDL_Surface* surface, SDL_Rect* rect);

private:

	SDLProgressBar(const SDLProgressBar&);
	SDLProgressBar& operator=(const SDLProgressBar&);

	SDL_Gradient my_pbGradient;
	SDL_Surface* my_pbBackground;
	int my_pbBackmode;
	int my_pbBlend;
	SDL_Color my_colorText;
	double my_percentCurrent;

};

#endif // SDLPROGRESSBAR_H

